module LibSpec
    ( specRun
    ) where

import Test.Hspec
-- import Test.QuickCheck
import System.Process
import System.Exit

-- Run a command and consider a good exit value a success; the
-- reason this is worth its own function is that we have to make
-- sure we fail in the right way, or we get the output as a
-- "foo\nbar\n" sort of string.
runCmd :: String -> [String] -> String -> IO ()
runCmd cmd args stdin = do
  (exit, stdout, stderr) <- readProcessWithExitCode cmd args stdin
  if exit /= ExitSuccess then
    -- Gives us the properly formatted output
    expectationFailure $ 
      "stdout: \n\n" ++ stdout ++
      "\n\nstderr: \n\n" ++ stderr
  else
    exit `shouldBe` ExitSuccess

specRun :: IO ()
specRun = do
  runCmd "stack-test-exe-1" [] ""
  runCmd "stack-test-exe-2" [] ""


